<?php
/**
 * @version   1.1 April 28, 2011
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2011 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('ROKINTROSCROLLER') or die('Restricted access');

require_once (JPath::clean(JPATH_SITE . '/components/com_content/helpers/route.php'));
require_once (JPath::clean(JPATH_SITE . '/components/com_content/models/articles.php'));
require_once (JPath::clean(JPATH_SITE . '/components/com_content/helpers/route.php'));
require_once (JPath::clean(JPATH_SITE . '/libraries/joomla/html/html/content.php'));

jimport('joomla.utilities.date');


class RokIntroScroller
{
    /**
     * @param  JRegistry $params
     * @return void
     */
    public function loadScripts(&$params)
    {
        JHTML::_('behavior.mootools');
        $doc = &JFactory::getDocument();
        $doc->addScript(JURI::Root(true) . '/modules/mod_rokintroscroller/rokintroscroller.js');
        $doc->addScriptDeclaration("
		window.addEvent('domready', function() {
			var rnu = new RokIntroScroller('rokintroscroller', {
				'arrows': {
					'effect': true,
					'opacity': " . $params->get('arrows_opacity', 0.35) . "
				},
				'scroll': {
					'duration': " . $params->get('duration') . ",
					'itemsPerClick': " . $params->get('items_per_click', 2) . ",
					'transition': Fx.Transitions.Quad.easeOut
				}
			});
		});");
    }

    /**
     * @param  $text
     * @param int $length
     * @return mixed|string
     */
    protected function prepareContent($text, $length = 300)
    {
        // strips tags won't remove the actual jscript
        $text = preg_replace("'<script[^>]*>.*?</script>'si", "", $text);
        $text = preg_replace('/{.+?}/', '', $text);
        // replace line breaking tags with whitespace
        // $text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
        // $text = strip_tags( $text );
        if (strlen($text) > $length) $text = substr($text, 0, $length) . "...";
        return $text;
    }

    /**
     * @param  JRegistry $params
     * @return array|mixed
     */
    public function getList(&$params){
        $conf =& JFactory::getConfig();
        if ($conf->getValue('config.caching') && $params->get('module_cache'))
        {
            $user =& JFactory::getUser();
            $cache =& JFactory::getCache('mod_rokintroscroller');
            $cache->setCaching(true);
            $lifetime = ($params->get('module_cache') == 1 && (int)$params->get('cache_time') > 0)?(int)$params->get('cache_time'): (int)$conf->getValue('config.cachetime')*60;
            $cache->setLifeTime($lifetime);
            $args = array(&$params);
            $checksum = md5($params->toString());
            $items = $cache->get(array($this, '_getList',), $args, 'mod_rokintroscroller-' . $user->get('aid', 0) . '-' . $checksum);
        }
        else
        {
            $items = $this->_getList($params);
        }
        return $items;
    }

    /**
     * @param  JRegistry $params
     * @return array
     */
    public function _getList(&$params)
    {
        $app =& JFactory::getApplication();
        $cparams =& $app->getParams('com_content');
        $count = (int)$params->get('count', 5);
        $catid = trim($params->get('catid'));
        $show_front = $params->get('show_front', 1);
        $ordering = $params->get('itemsOrdering');
        $user_id = $params->get('user_id');

        // ordering
        switch ($ordering)
        {
            case 'date' :
                $orderby = 'a.created ASC';
                break;
            case 'rdate' :
                $orderby = 'a.created DESC';
                break;
            case 'alpha' :
                $orderby = 'a.title';
                break;
            case 'ralpha' :
                $orderby = 'a.title DESC';
                break;
            case 'order' :
                $orderby = 'a.ordering';
                break;
            default :
                $orderby = 'a.id DESC';
                break;
        }


        jimport('joomla.application.component.model');
        // Get an instance of the generic articles model
        $model = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

        $appParams = $app->getParams();
        $model->setState('params', $appParams);


        // Set the filters based on the module params
        $model->setState('list.start', 0);
        $model->setState('list.limit', $count);
        $model->setState('filter.published', 1);


        // Access filter
        $access = !JComponentHelper::getParams('com_content')->get('show_noauth');
        $authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
        $model->setState('filter.access', $access);

        // Category filter
        $model->setState('filter.category_id', $catid);

        // User filter
        $userId = JFactory::getUser()->get('id');
        switch ($user_id)
        {
            case 'by_me':
                $model->setState('filter.author_id', (int)$userId);
                break;
            case 'not_me':
                $model->setState('filter.author_id', $userId);
                $model->setState('filter.author_id.include', false);
                break;

            case 0:
                break;

            default:
                $model->setState('filter.author_id', $user_id);
                break;
        }

        //  Featured switch
        switch ($show_front)
        {
            case 1:
                $model->setState('filter.featured', 'show');
                break;
            case 0:
                $model->setState('filter.featured', 'hide');
                break;
            default:
                $model->setState('filter.featured', 'only');
                break;
        }


        //Set the Start and Limit
        $model->setState('list.start', 0);
        $model->setState('list.limit', $count);

        $ordering = explode(' ', $orderby);
        $model->setState('list.ordering', $ordering[0]);
        $model->setState('list.direction', isset($ordering[1]) ? $ordering[1] : null);

        $rows = $model->getItems();

        $i = 0;
        $lists = array();

        if (is_array($rows) && count($rows) > 0)
        {
            foreach ($rows as $row)
            {
                //process content plugins
                $text = JHTML::_('content.prepare', $row->introtext, $cparams);
                $lists[$i]->id = $row->id;
                $lists[$i]->created = $row->created;
                $lists[$i]->modified = $row->modified;
                $lists[$i]->title = htmlspecialchars($row->title);
                $lists[$i]->introtext = $this->prepareContent($row->introtext, $params->get('preview_count', 300));
                $lists[$i]->link = $lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->id, $row->catid));
                $i++;
            }
        }
        return $lists;
    }

}
